//    FILE: MagicMods_eGpu_Firmware.ino
//  AUTHOR: MagciMods
// VERSION: 1.0
// PURPOSE: eGpu Firmware
//    DATE: 01-11-2016
//     URL: https://magicmods.net

// TODO
// - Finish timer
// - Finish comments


#include <ADC.h>
#include <DallasTemperature.h>
#include<CountUpDownTimer.h>
#include <OneWire.h>
#include <Nextion.h>
#include <FastLED.h>
#include <Filters.h>
#include <Arduino.h>



#define DATA_PIN    A6
#define LED_TYPE    WS2811
#define COLOR_ORDER GRB
#define NUM_LEDS    61
CRGB leds[NUM_LEDS];

#define BRIGHTNESS          80
#define FRAMES_PER_SECOND  120
uint32_t brightness = 50;

// COOLING: How much does the air cool as it rises?
// Less cooling = taller flames.  More cooling = shorter flames.
// Default 50, suggested range 20-100
#define COOLING  80

// SPARKING: What chance (out of 255) is there that a new spark will be lit?
// Higher chance = more roaring fire.  Lower chance = more flickery fire.
// Default 120, suggested range 50-200.
#define SPARKING 70

bool gReverseDirection = false;

unsigned long previousMillisWattsDriveMap = 0;

unsigned long printPeriodWatts = 1000; // in milliseconds
// Track time in milliseconds since last reading
unsigned long previousMillisWatts = 0;

unsigned long printPeriodTemps = 1600; // in milliseconds
// Track time in milliseconds since last reading
unsigned long previousMillisTemps = 0;

bool changepattern = true;



//Watts
float testFrequency = 50.0;                     // test signal frequency (Hz)
float windowLength = 25.0 / testFrequency;   // how long to average the signal, for statistist
int sensorValue = 0;
float intercept = -0.11; // to be adjusted based on calibration testing
float slope = 0.026; // to be adjusted based on calibration testing
float current_amps; // estimated actual current in amps
int W;
int lastW;
int wattsDrive;
unsigned long wattsDriveMap;
ADC adc;
RunningStatistics inputStats;                 // create statistics to look at the raw test signal

//Timer
CountUpDownTimer T(UP, LOW); // Default precision is HIGH, but you can change it to also be LOW
unsigned long Watch, _micro, time = micros();
unsigned int Clock = 0, R_clock;
boolean Reset = false, Stop = false, Paused = false, _type;
volatile boolean timeFlag = false;
#define DOWN 0
#define UP 1

//Fans
int fanTemp;
int tempMin = 10;   // the temperature to start the buzzer
int tempMax = 50;
int fanPin = 6;       // the pin where fan is connected
int fanSpeed = 0;
int fanSpeedDisplay = 0;
bool SetTempMinBool = false;
bool SetTempMaxBool = false;

//Temps
//volatile uint32_t timerCounterTemps;
int temps[3];
//volatile bool tempsUpdated = false;
//volatile int16_t total;
int lastTemps[3];


// Setup a oneWire instance to communicate with any OneWire devices
#define ONE_WIRE_BUS A1
OneWire oneWire(ONE_WIRE_BUS);
// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);
//#define TEMPERATURE_PRECISION 9

int iTH = 0;
int iTF = 0;

//Buzzer
#define PinTone 5
#define FreqTone 100
#define TimeTone 100
#define PinTone2 5
#define FreqTone2 1000
#define TimeTone2 300
#define PinTone3 5
#define FreqTone3 4000
#define TimeTone3 300

// Nextion - Declare object [page id:0,component id:3, component name: "n0"]
NexGauge zgpuw  = NexGauge(1, 1, "zgpuw");
NexGauge zgpuc  = NexGauge(1, 2, "zgpuc");
NexGauge zpsu  = NexGauge(2, 3, "zpsu");
NexGauge zbox  = NexGauge(2, 4, "zbox");

NexNumber ngpuw = NexNumber(1, 3, "ngpuw");
NexNumber ngpuc = NexNumber(1, 4, "ngpuc");
NexNumber npsu = NexNumber(2, 7, "npsu");
NexNumber nbox = NexNumber(2, 8, "nbox");
NexNumber nth = NexNumber(2, 9, "nth");
NexNumber ntm = NexNumber(2, 11, "ntm");
NexNumber nts = NexNumber(2, 12, "nts");
NexNumber fspeed = NexNumber(3, 1, "fspeed");
NexNumber MinTemp = NexNumber(4, 2, "MinTemp");
NexNumber MaxTemp = NexNumber(4, 3, "MaxTemp");

NexPage HomePage = NexPage(1, 0, "HomePage");
NexPage LedPage = NexPage(3, 0, "LedPage");
NexPage FansPage = NexPage(4, 0, "FansPage");

NexHotspot bt0 = NexHotspot(3, 4, "bt0");
NexHotspot bt1 = NexHotspot(3, 5, "bt1");
NexHotspot bt2 = NexHotspot(3, 6, "bt2");
NexHotspot bt3 = NexHotspot(3, 7, "bt3");
NexHotspot bt4 = NexHotspot(3, 8, "bt4");
NexHotspot bt5 = NexHotspot(3, 9, "bt5");
NexHotspot bt6 = NexHotspot(3, 10, "bt6");

NexButton Led = NexButton(1, 11, "Led");
NexButton Fan = NexButton(1, 12, "Fan");
NexButton bl0 = NexButton(3, 3, "bl0");
NexButton bl1 = NexButton(3, 2, "bl1");
NexButton bf0 = NexButton(4, 7, "bf0");
NexButton bf1 = NexButton(4, 8, "bf1");

NexSlider h0 = NexSlider(3, 1, "h0");

//char buffer[100] = {0};

NexTouch *nex_listen_list[] = {
  &Led, &Fan, &bl0, &bl1, &bf0, &bf1,
  &bt0, &bt1, &bt2, &bt3, &bt4, &bt5, &bt6, &MinTemp, &MaxTemp, &h0,
  NULL
};

//Pages
bool HomeP;
bool FansP;
bool LedP;

// ADC Readings
void adc0_isr() {
  int value;
  value = adc.readSingle(ADC_0);
  inputStats.input(value);  // log to Stats function
  adc.startSingleRead(A0, ADC_0);
}

// List of patterns to cycle through.  Each is defined as a separate function below.
typedef void (*SimplePatternList[])();

SimplePatternList gPatterns = {
  rainbowWithGlitter,
  fire,
  confetti,
  juggle,
  //bpm,
  bpm2,
  sinelon,
  rainbow
};

uint8_t gCurrentPatternNumber = 0; // Index number of which pattern is current
uint8_t gHue = 0; // rotating "base color" used by many of the patterns


void Timer() {
  T.Timer(); // run the timer
  if (T.TimeHasChanged() && HomeP ) // this prevents the time from being constantly shown.
  {
    nts.setValue(T.ShowSeconds());
    nth.setValue(T.ShowHours());
    ntm.setValue(T.ShowMinutes());
  }
}

//Temps
float dallas(int x, byte start) {
  OneWire ds(x);
  byte i;
  byte data[2];
  int16_t result;
  do {
    ds.reset();
    ds.write(0xCC);
    ds.write(0xBE);
    for ( i = 0; i < 2; i++) data[i] = ds.read();
    result = (data[1] << 8) | data[0];
    result >> 4; if (data[1] & 128) result |= 61440;
    if (data[0] & 8) ++result;
    ds.reset();
    ds.write(0xCC);
    ds.write(0x44, 1);
    if (start) delay(1000);
  } while (start--);
  float celsius = (float) result / 16.0;
  //if (celsius > 100)celsius = celsius - 4096;
  return celsius;
}

void fanPWM () {
  fanTemp = temps[0];
  if (fanTemp < tempMin) {
    fanSpeed = 0;
    analogWrite(fanPin, 0);
  } else if (fanTemp >= tempMax) {
    fanSpeed = 100;
  }
  if (fanTemp >= tempMin) {
    fanSpeed = map(fanTemp, tempMin, tempMax, 0, 255);
    analogWrite(fanPin, fanSpeed);
    fanSpeedDisplay = fanSpeed;
    fanSpeedDisplay = map(fanSpeedDisplay, 0 , 255, 0 , 100);
    if (FansP) {
      fspeed.setValue(fanSpeedDisplay);
    }
  }
}


void TempGpuRead() {
  temps[0] = dallas(A1, 0);
}

void TempGpuWriteNum() {
  ngpuc.setValue(temps[0]);
}

void TempGpuWriteGauge() {
  int zgpucm = temps[0];

  if (temps[0] >= 0 && temps[0] < 15) {
    zgpucm = map(zgpucm, 0, 15, 310 , 360);
    zgpuc.setValue(zgpucm);
  } else {
    zgpucm = map(zgpucm, 15 , 90, 0, 230);
    zgpuc.setValue(zgpucm);
  }
}

void TempPsuRead() {
  temps[1] = dallas(A2, 0);
}

void TempPsuWriteNum() {
  npsu.setValue(temps[1]);
}

void TempPsuWriteGauge() {
  int zpsum = (temps[1]);
  if (temps[1] >= 0 && temps[1] < 60) {
    zpsum = map(zpsum, 0, 60, 270 , 360);
    zpsu.setValue(zpsum);
  } else {
    zpsum = map(zpsum, 60 , 90, 0, 45);
    zpsu.setValue(zpsum);
  }
}

void TempBoxRead() {
  temps[2] = dallas(A3, 0);
}

void TempBoxWriteNum() {
  nbox.setValue(temps[2]);
}

void TempBoxWriteGauge() {
  int zboxm = (temps[2]);
  zboxm = map(zboxm, 0, 60, 230, 135);
  zbox.setValue(zboxm);

}


void watts () {
  //Serial.print( "\tsigma: " ); Serial.print( inputStats.sigma() );
  // convert signal sigma value to current in amps
  current_amps = intercept + slope * inputStats.sigma();
  //Serial.print( "\tamps: " ); Serial.print( current_amps );
  W = (current_amps * 240);
  wattsDrive = W;
  wattsDriveMap = map(wattsDrive, 0, 300, 20, 0);
}

void wattsDisplay () {
  if (lastW != W) {
    ngpuw.setValue(W);
    int zgpuwm = (W);
    
    if (W >= 0 && W < 50) {
      zgpuwm = map(zgpuwm, 0, 50, 310 , 360);
      zgpuw.setValue(zgpuwm);
    } else {
      zgpuwm = map(zgpuwm, 50 , 300, 0, 230);
      zgpuw.setValue(zgpuwm);
    }
    lastW = W;
  }
}

#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))

void nextPattern() {
  // add one to the current pattern number, and wrap around at the end
  if (changepattern != false) {
    gCurrentPatternNumber = (gCurrentPatternNumber + 1) % ARRAY_SIZE( gPatterns);
  }
}

void bt0PushCallback(void *ptr) {
  gCurrentPatternNumber = 0;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bt1PushCallback(void *ptr) {
  gCurrentPatternNumber = 1;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bt2PushCallback(void *ptr) {
  changepattern = true;
  tone(PinTone, FreqTone, TimeTone);
}

void bt3PushCallback(void *ptr) {
  gCurrentPatternNumber = 3;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bt4PushCallback(void *ptr) {
  gCurrentPatternNumber = 4;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bt5PushCallback(void *ptr) {
  gCurrentPatternNumber = 5;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bt6PushCallback(void *ptr) {
  gCurrentPatternNumber = 6;
  changepattern = false;
  tone(PinTone, FreqTone, TimeTone);
}

void bl0PopCallback(void *ptr) {
  HomeP = true;
  LedP = false;
  FansP = false;
  HomePage.show();
  TempGpuWriteNum();
  TempGpuWriteGauge();
  TempPsuWriteGauge();
  TempBoxWriteGauge();
  tone(PinTone, FreqTone, TimeTone);
}

void bl1PopCallback(void *ptr) {
  HomeP = false;
  LedP = false;
  FansP = true;
  FansPage.show();
  TempGpuWriteNum();
  TempPsuWriteNum();
  TempBoxWriteNum();
  tone(PinTone, FreqTone, TimeTone);
}

void LedPopCallback(void *ptr) {
  HomeP = false;
  LedP = true;
  FansP = false;
  LedPage.show();
  tone(PinTone, FreqTone, TimeTone);
}

void FanPopCallback(void *ptr) {
  HomeP = false;
  LedP = false;
  FansP = true;
  FansPage.show();
  TempGpuWriteNum();
  TempPsuWriteNum();
  TempBoxWriteNum();
  tone(PinTone, FreqTone, TimeTone);
}

void bf0PopCallback(void *ptr) {
  HomeP = true;
  LedP = false;
  FansP = false;
  HomePage.show();
  TempGpuWriteNum();
  TempGpuWriteGauge();
  TempPsuWriteGauge();
  TempBoxWriteGauge();
  tone(PinTone, FreqTone, TimeTone);
}

void bf1PopCallback(void *ptr) {
  HomeP = false;
  LedP = true;
  FansP = false;
  LedPage.show();
  tone(PinTone, FreqTone, TimeTone);
}

void MinTempPopCallback(void *ptr) {
  tone(PinTone, FreqTone, TimeTone);
}

void MaxTempPopCallback(void *ptr) {
  tone(PinTone, FreqTone, TimeTone);
}

void h0PopCallback(void *ptr) {
  dbSerialPrintln("h0PopCallback");
  uint32_t number = 0;
  h0.getValue(&brightness);
  FastLED.setBrightness(brightness);
//  Serial.println(brightness);
}

void rainbow() {
  // FastLED's built-in rainbow generator
  fill_rainbow( leds, NUM_LEDS, gHue, 7);
}

void rainbowWithGlitter() {
  // built-in FastLED rainbow, plus some random sparkly glitter
  rainbow();
  addGlitter(80);
}

void addGlitter( fract8 chanceOfGlitter) {
  if ( random8() < chanceOfGlitter) {
    leds[ random16(NUM_LEDS) ] += CRGB::White;
  }
}

void confetti() {
  // random colored speckles that blink in and fade smoothly
  fadeToBlackBy( leds, NUM_LEDS, 10);
  int pos = random16(NUM_LEDS);
  leds[pos] += CHSV( gHue + random8(64), 200, 255);
}

void sinelon()
{
  // a colored dot sweeping back and forth, with fading trails
  fadeToBlackBy( leds, NUM_LEDS, 20);
  int pos = beatsin16(13, 0, NUM_LEDS);
  leds[pos] += CHSV( gHue, 255, 192);
}

void bpm() {
  // colored stripes pulsing at a defined Beats-Per-Minute (BPM)
  uint8_t BeatsPerMinute = 62;
  CRGBPalette16 palette = PartyColors_p;
  uint8_t beat = beatsin8( BeatsPerMinute, 64, 255);
  for ( int i = 0; i < NUM_LEDS; i++) { //9948
    leds[i] = ColorFromPalette(palette, gHue + (i * 2), beat - gHue + (i * 10));
  }
}

void bpm2() {
  // colored stripes pulsing at a defined Beats-Per-Minute (BPM)
  uint8_t BeatsPerMinute = W;
  CRGBPalette16 palette = PartyColors_p;
  uint8_t beat = beatsin8( BeatsPerMinute, 64, 255);
  for ( int i = 0; i < NUM_LEDS; i++) { //9948
    leds[i] = ColorFromPalette(palette, gHue + (i * 2), beat - gHue + (i * 10));
  }
}

void juggle() {
  // eight colored dots, weaving in and out of sync with each other
  fadeToBlackBy( leds, NUM_LEDS, 20);
  byte dothue = 0;
  for ( int i = 0; i < 8; i++) {
    leds[beatsin16(i + 7, 0, NUM_LEDS)] |= CHSV(dothue, 200, 255);
    dothue += 32;
  }
}

void fire() {
  // Array of temperature readings at each simulation cell
  static byte heat[NUM_LEDS];

  // Step 1.  Cool down every cell a little
  for ( int i = 0; i < NUM_LEDS; i++) {
    heat[i] = qsub8( heat[i],  random8(0, ((COOLING * 10) / NUM_LEDS) + 2));
  }

  // Step 2.  Heat from each cell drifts 'up' and diffuses a little
  for ( int k = NUM_LEDS - 1; k >= 2; k--) {
    heat[k] = (heat[k - 1] + heat[k - 2] + heat[k - 2] ) / 3;
  }

  // Step 3.  Randomly ignite new 'sparks' of heat near the bottom
  if ( random8() < SPARKING ) {
    int y = random8(7);
    heat[y] = qadd8( heat[y], random8(160, 255) );
  }

  // Step 4.  Map from heat cells to LED colors
  for ( int j = 0; j < NUM_LEDS; j++) {
    CRGB color = HeatColor( heat[j]);
    int pixelnumber;
    if ( gReverseDirection ) {
      pixelnumber = (NUM_LEDS - 1) - j;
    } else {
      pixelnumber = j;
    }
    leds[pixelnumber] = color;
  }
}

void setup() {

  nexInit();
  Serial.begin(115200);
  delay(1000);
  Serial.println("MagicMods Egpu");
  sensors.begin();
  T.StartTimer();


  //Fan
  pinMode(fanPin, OUTPUT);

  //Led
  FastLED.addLeds<LED_TYPE, DATA_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
  FastLED.setBrightness(BRIGHTNESS);

  bt0.attachPush(bt0PushCallback, &bt0);
  bt1.attachPush(bt1PushCallback, &bt1);
  bt2.attachPush(bt2PushCallback, &bt2);
  bt3.attachPush(bt3PushCallback, &bt3);
  bt4.attachPush(bt4PushCallback, &bt4);
  bt5.attachPush(bt5PushCallback, &bt5);
  bt6.attachPush(bt6PushCallback, &bt6);

  bf0.attachPop(bf0PopCallback, &bf0);
  bf1.attachPop(bf1PopCallback, &bf1);
  bl0.attachPop(bl0PopCallback, &bl0);
  bl1.attachPop(bl1PopCallback, &bl1);
  Led.attachPop(LedPopCallback, &Led);
  Fan.attachPop(FanPopCallback, &Fan);
  h0.attachPop(h0PopCallback, &h0);
  
  MinTemp.attachPop(MinTempPopCallback, &MinTemp);
  MaxTemp.attachPop(MaxTempPopCallback, &MaxTemp);

  HomeP = true;
  FansP = false;
  LedP = false;

  inputStats.setWindowSecs( windowLength );

  adc.setResolution(10);
  adc.setConversionSpeed(ADC_LOW_SPEED);
  adc.enableInterrupts(ADC_0);
  adc.startSingleRead(A0, ADC_0);

  dallas(A1, 1);
  dallas(A2, 1);
  dallas(A3, 1);

//  delay(1000);

  TempGpuRead();
  TempPsuRead();
  TempBoxRead();

//  delay(1000);

  HomePage.show();

  TempGpuWriteNum();
  TempGpuWriteGauge();
  TempPsuWriteGauge();
  TempBoxWriteGauge();

  tone(PinTone, FreqTone, TimeTone);
  tone(PinTone2, FreqTone2, TimeTone2);
  tone(PinTone3, FreqTone3, TimeTone3);
}

void loop () {

  nexLoop(nex_listen_list);

  EVERY_N_MILLISECONDS(20) {
    gPatterns[gCurrentPatternNumber]();

    adc.disableInterrupts(ADC_0);
    FastLED.show();
    adc.enableInterrupts(ADC_0);
  }

  FastLED.setBrightness(brightness);

  EVERY_N_SECONDS( 1 ) {
    Timer();
  }


  EVERY_N_SECONDS( 6 ) {
    nextPattern();
  }

  if ((unsigned long)(millis() - previousMillisWattsDriveMap) >= wattsDriveMap) {
    previousMillisWattsDriveMap = millis();   // update time
    gHue++;
  }

  EVERY_N_SECONDS ( 3 ) {
    fanPWM();
  }


  EVERY_N_MILLISECONDS ( 500 ) {
    if (HomeP) {
      if (iTH == 0) {
        TempGpuRead();
        //Serial.println("TempGpuRead");
        iTH++;
      } else if (iTH == 1) {
        TempGpuWriteNum();
        //Serial.println("TempGpuWriteNum");
        iTH++;
      } else if (iTH == 2) {
        TempGpuWriteGauge();
        //Serial.println("TempGpuWriteGauge");
        iTH++;
      } else if (iTH == 3) {
        TempPsuRead();
        //Serial.println("TempPsuReap");
        iTH++;
      } else if (iTH == 4) {
        TempPsuWriteGauge();
        //Serial.println("TempPsuWriteGauge");
        iTH++;
      } else if (iTH == 5) {
        TempBoxRead();
        //Serial.println("TempBoxRead");
        iTH++;
      } else if (iTH == 6) {
        TempBoxWriteGauge();
        //Serial.println("TempBoxRead");
        iTH++;
      } else if (iTH == 7) {
        iTH = 0;
      }
    } else if (FansP) {
      if (iTF == 0) {
        TempGpuRead();
        //Serial.println("TempGpuRead");
        iTF++;
      } else if (iTF == 1) {
        TempGpuWriteNum();
        //Serial.println("ngpuc.setValue");
        iTF++;
      } else if (iTF == 2) {
        TempPsuRead();
        //Serial.println("TempPsuReap");
        iTF++;
      } else if (iTF == 3) {
        TempPsuWriteNum();
        //Serial.println("TempPsuWriteNum");
        iTF++;
      } else if (iTF == 4) {
        TempBoxRead();
        //Serial.println("TempBoxRead");
        iTF++;
      } else if (iTF == 5) {
        TempBoxWriteNum();
        //Serial.println("TempBoxWriteNum");
        iTF++;
      } else if (iTF == 6) {
        iTF = 0;
      }

    }

  }

  EVERY_N_MILLISECONDS( 100 ) {
    watts();
    if (HomeP) {
      wattsDisplay();
    }
  }
}
